exports.main = async function(data)
{
	await ext("com-api-users").user.init(data)	

	data.load = {}
	data.load.view = {}
	data.load.view.component = {}
	data.load.view.modules = {}
	data.load.view.plugins = {}

	data.load.view.css = {}
	data.load.view.css.plugin = {}
	data.load.view.css.module = {}
	data.load.view.css.component = {}

	data.load.view.js = {}
	data.load.view.js.plugin = {}
	data.load.view.js.module = {}
	data.load.view.js.component = {}
	data.load.view.ready_js = []

	data.load.view.modules.position = {}

	data.load.component = {}
	data.load.plugins = {}
	

	
	try
	{
		
		return this[data.user.request.type](data)
	}
	catch(e)
	{
		data.server.response_status = 404
	}
		
}


exports.http = async function(data)
{
	
	await ext('com-api-system').load.plugins(data)


	data.load.view.component = await ext('com-api-system').load.component(data)
	
	await ext('com-api-system').load.modules(data)
	if(data.user.request.redirect!=undefined)
	{
		data.server.response_status = 302
		data.server.set_header['Location'] = data.user.request.redirect
		return ""
	}
	
	return await ext('com-api-system').load.view(data)
}


exports.ajax = async function(data)
{
	//ajax/component/admin/repository/assembly_list/update/search/1
	var type_ext = await ext('lib-request').url_segment(1, data.server.req.url)
	var r = await ext('com-api-system').load[type_ext](data)
	if(typeof r == 'object')
	{
		r = JSON.stringify(r)
	}	

	return r
}

exports.api = async function(data)
{
	data.server.set_header = {'Content-Type': "application/json; charset=utf-8"}
	var type_ext = await ext('lib-request').url_segment(1, data.server.req.url)
	var r = await ext('com-api-system').load[type_ext](data)
	if(typeof r == 'object')
	{
		r = JSON.stringify(r)
	}	

	return r
}

exports.ws = async function(data)
{
	var r = await ext('com-api-system').load[data.user.request.type_ext](data)
	if(typeof r == 'object')
	{
		r = JSON.stringify(r)
	}	

	return r
}


exports.file = async function(data)
{
	var clear_url = await ext('lib-request').clear_url(data.server.req.url)

	var res = await ext('com-api-filesbrowser').dir.lock_dirs(clear_url)


	if(res!=undefined)
	{
		data.server.response_status = 404
		return "no file"
	}
	
	var res = await ext('com-api-filesbrowser').file.mime(clear_url)
	

	if(res!=undefined)
	{
		data.server.response_status = 200
		data.server.set_header['Content-Type'] = res.mime;
		//data.server.set_header['Content-Disposition'] = "attachment; filename=" + res.name;
		var r = await ext('com-api-filesbrowser').file.read(clear_url)			
		return r
	}
	else
	{
		data.server.response_status = 404
		return "no file"
	}
}

exports.daemons = async function(data)
{
	var daemons_list = {}
	var mtime_files = {}
	

	while(true)
	{

		var read_dir_daemons = await ext('com-api-filesbrowser').dir.read("daemons")
		
		if(read_dir_daemons!="0")
		{
			for(var d in read_dir_daemons)
			{

				if(daemons_list[read_dir_daemons[d]] == undefined)
				{
					daemons_list[read_dir_daemons[d]] = {}
				}

				var read_dir = await ext('com-api-filesbrowser').dir.read( "daemons/"+read_dir_daemons[d])
				if(read_dir!="0")
				{
					for(var i in read_dir)
					{
						
						var stat_file = await ext('node-fs').promises.stat(await ext('com-api-system').config.path_root+'/daemons/'+read_dir_daemons[d]+'/'+read_dir[i], function(err,stat){
			    			return stat
						});

						
						if(daemons_list[read_dir_daemons[d]][read_dir[i]] == undefined)
						{
							mtime_files[read_dir[i]] = stat_file['mtime'].toString()
							daemons_list[read_dir_daemons[d]][read_dir[i]] = require(await ext('com-api-system').config.path_root+'daemons/'+read_dir_daemons[d]+'/'+read_dir[i]);
							daemons_list[read_dir_daemons[d]][read_dir[i]].start(data);

						}

						if(mtime_files[read_dir[i]]!=stat_file['mtime'].toString())
						{
							delete(daemons_list[read_dir_daemons[d]][read_dir[i]])
							delete require.cache[require.resolve('daemons/'+read_dir_daemons[d]+'/'+read_dir[i])]
						}
					}
				}
			}
			
		}	
		
		await ext('lib-util').sleep(50)

	} 
		
}